unit quicktest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,QuickRTTI;

type
TNotes = class(Tpersistent)
 private
   fNotes:string;
 published
   property Data:String read fnotes write fnotes;
 end;

TContact = class  (TPersistent)
 private
  fname,faddress,fcity,fstate,fzip:String;
  fnotes:TNotes; flines:tstringlist;
  fmycollect:TCollection;
 public
  constructor create;
  destructor destroy;override;
 published
  property Name:String read fname write fname;
  property Address:String read faddress write faddress;
  property City:String read fcity write fcity;
  property State:String read fstate write fstate;
  property Zip:String read fzip write fzip;
  property Notes:TNotes read fnotes write fnotes;
  property Lines:Tstringlist read flines write flines;
  property MyCollect:TCollection read fmycollect write fmycollect;
 end;

 TMyItem = Class(TCollectionItem)
 private
  fname:String;
 published
   property Name:String read fname write fname;
 end;

  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    lblTime: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    fquick:TQuickRTTI;
    c:TContact;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

constructor TContact.create;
var itm:TMyItem;
begin
 fnotes:=tnotes.create;
 flines:=tstringlist.create;
 flines.add ('Howdy!');
 flines.add ('My Name is mike');
 fmycollect:=TCollection.Create(TMyItem);
 itm:= TMyItem(fmycollect.add);
 itm.Name := 'Test Item';
end;

destructor TContact.destroy;
begin
 try
  fmycollect.Clear;
  fmycollect.free;
  fnotes.data:='';
  fnotes.free;
  fname:='';faddress:='';fcity:='';fstate:='';fzip:='';
   flines.Clear ;
   flines.free;
 finally
  inherited destroy;
 end;
end;
procedure TForm1.Button1Click(Sender: TObject);
begin
{ask RTTI to build the XML on the fly!}
memo1.lines.text:=fquick.XML ;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
fquick:=TQuickRTTI.create;

{Here is my object}
c:=TContact.Create ;
c.name:='Ann Johnson';
c.Address :='424 S. Division Street'    ;
c.city:='Chenoa';
c.state:='IL';
c.zip:='61726';
{A sub object..just for fun}
c.Notes.Data := 'Test Data';
{Tell QuickRTTI where to find the object}
fquick.RTTIObject :=c;

fquick.TagName := 'CONTACT';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
{Ask RTTI to read the XML and populate our object!}
fquick.XML:= memo1.lines.text;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
fquick.free;
c.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
var st,en,last,elast,avg,i:integer;h:String;
begin
st:=Gettickcount;
for i:= 0 to 9999 do
 begin

  h:=fquick.xml;
  h:=h+' '; {ensure it doesn't optimize the line right out!}
  fquick.xml:=h;

 end;
en:=Gettickcount;
lblTime.caption:=(Floattostr( ( (en-st)/1000)) )+ ' seconds ';

end;

end.
